﻿using System;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Net;
using System.IO;
using System.Text;
using System.Xml;
using System.Collections;
using System.Collections.Generic;
using System.Net.Mail;
using System.Text.RegularExpressions;

public partial class TutorialCode_Yahoo_OAuth_2 : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (Request.QueryString["code"] != null)
            GetAccessToken();
    }
    protected void yahooButton_Click(object sender, EventArgs e)
    {
        string consumerKey = "Your Consumer Key";
        string returnUrl = "http://www.demo.yogihosting.com/aspnet/Yahoo-OAuth-2/";
        /*Space in returnUrl will give error*/

        /*Sending User To Authorize Access Page*/
        string url = "https://api.login.yahoo.com/oauth2/request_auth?client_id=" + consumerKey + "&redirect_uri=" + returnUrl + "&response_type=code&language=en-us";
        Response.Redirect(url);
        /*End*/
    }
    public void GetAccessToken()
    {
        string consumerKey = "Your Consumer Key";
        string consumerSecret = "Your Consumer Secret";

        string returnUrl = "http://www.demo.yogihosting.com/aspnet/Yahoo-OAuth-2/";
        //string encodedReturnUrl = System.Web.HttpUtility.UrlEncode(returnUrl);

        /*Exchange authorization code for Access Token by sending Post Request*/
        Uri address = new Uri("https://api.login.yahoo.com/oauth2/get_token");

        // Create the web request  
        HttpWebRequest request = WebRequest.Create(address) as HttpWebRequest;

        // Set type to POST  
        request.Method = "POST";
        request.ContentType = "application/x-www-form-urlencoded";
        byte[] headerByte = System.Text.Encoding.UTF8.GetBytes(consumerKey + ":" + consumerSecret);
        string headerString = System.Convert.ToBase64String(headerByte);
        request.Headers["Authorization"] = "Basic " + headerString;

        // Create the data we want to send  
        StringBuilder data = new StringBuilder();
        data.Append("client_id=" + consumerKey);
        data.Append("&client_secret=" + consumerSecret);
        data.Append("&redirect_uri=" + returnUrl);
        data.Append("&code=" + Request.QueryString["code"]);
        data.Append("&grant_type=authorization_code");

        // Create a byte array of the data we want to send  
        byte[] byteData = UTF8Encoding.UTF8.GetBytes(data.ToString());

        // Set the content length in the request headers  
        request.ContentLength = byteData.Length;

        // Write data  
        using (Stream postStream = request.GetRequestStream())
        {
            postStream.Write(byteData, 0, byteData.Length);
        }

        // Get response  
        string responseFromServer = "";
        try
        {
            using (HttpWebResponse response = request.GetResponse() as HttpWebResponse)
            {
                // Get the response stream  
                StreamReader reader = new StreamReader(response.GetResponseStream());
                responseFromServer = reader.ReadToEnd();
                ShowReceivedData(responseFromServer);
            }
        }
        catch (Exception ex)
        {
        }
    }

    public void ShowReceivedData(string responseFromServer)
    {
        responseFromServer = responseFromServer.Substring(1, responseFromServer.Length - 2);
        string accessToken = "", xoauthYahooGuid = "", refreshToken = "", tokenType = "", expiresIn = "";
        string[] splitByComma = responseFromServer.Split(',');
        foreach (string value in splitByComma)
        {
            if (value.Contains("access_token"))
            {
                string[] accessTokenSplitByColon = value.Split(':');
                accessToken = accessTokenSplitByColon[1].Replace('"'.ToString(), "");
            }
            else if (value.Contains("xoauth_yahoo_guid"))
            {
                string[] xoauthYahooGuidSplitByColon = value.Split(':');
                xoauthYahooGuid = xoauthYahooGuidSplitByColon[1].Replace('"'.ToString(), "");
            }
            else if (value.Contains("refresh_token"))
            {
                string[] refreshTokenSplitByColon = value.Split(':');
                refreshToken = refreshTokenSplitByColon[1].Replace('"'.ToString(), "");
            }
            else if (value.Contains("token_type"))
            {
                string[] tokenTypeSplitByColon = value.Split(':');
                tokenType = tokenTypeSplitByColon[1].Replace('"'.ToString(), "");
            }
            else if (value.Contains("expires_in"))
            {
                string[] expiresInSplitByColon = value.Split(':');
                expiresIn = expiresInSplitByColon[1].Replace('"'.ToString(), "");
            }
        }
        dataDiv.InnerHtml = "Access Token:- <b>" + accessToken + "</b><br/><br/> Refresh Token:- <b>" + refreshToken + "</b><br/><br/> XOauth Yahoo Guid:- <b>" + xoauthYahooGuid + "</b><br/><br/> Token Type:- <b>" + tokenType + "</b><br/><br/> Expires In:- <b>" + expiresIn + "</b>";
    }
}